import java.util.Formatter;

public class Simulation {

    private int diceNumber;
    private int tossNumber;
    private Dice dice;
    private Bins bins;


    public Simulation(int diceNumber, int tossNumber, Dice dice, Bins bins) {
        this.diceNumber = diceNumber;
        this.tossNumber = tossNumber;
        this.dice = new Dice(diceNumber);
        this.bins = new Bins(diceNumber);
    }

    public void startSimulation() {
        for (int i = 0; i < tossNumber; i++) {
            bins.incrementBin(dice.tossAndSum());
        }
    }

    public String print() {
        startSimulation();
        StringBuilder result = new StringBuilder();
        Formatter format = new Formatter(result);

        result.append("***\n Simulation of ");
        result.append(diceNumber);
        result.append(" dice tossed for ");
        result.append(tossNumber);
        result.append(" times.\n*** \n \n");
        for (int i=0; i<((diceNumber*6)-(diceNumber)+1); i++) {
            int timesThrown = bins.getBin(i+diceNumber);
            format.format("%2d", i+diceNumber);
            result.append(" : ");
            format.format("%10d", bins.getBin(i+diceNumber));
            result.append(": ");
            format.format("%.2f", (double)timesThrown/(double)tossNumber);
                for(int j=0; j<(((double)timesThrown/(double)tossNumber)*100); j++){
                    {result.append(" *");}
                    }
                    result.append("\n");

        }
        String printAns = result.toString();
        return printAns;
    }
}
